<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: user.inc.php,v 1.41 2004/02/04 16:54:53 vdanen Exp $
//
// Anthill user functions

function do_Login($uname,$passwd)
{
    global $_CONF, $config, $db;

    $dbdate = date("YmdHis");
    $result = $db->query("SELECT * FROM users WHERE (uname = '$uname') AND (deleted = '0')");
    dberror($result);
    $user   = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();
    $cpass = md5($passwd);
    if ($user['passwd'] != $cpass)
    {
        $uid    = "0";
    } else {
        $userdata = do_getuserdata($uname);
        $_USER    = $userdata;
        $uid      = $_USER['uid'];
        $sessid   = do_newsession($uid, $_SERVER['REMOTE_ADDR'], $_CONF['cookie_timeout_session']);
        do_setsessioncookie($sessid, $_CONF['cookie_timeout_session'], $_CONF['cookie_session'], $_CONF['cookie_path'], $_CONF['cookie_domain'], $_CONF['cookie_secure']);
        // update laston/thison in user records
        $laston   = $db->getOne("SELECT thison FROM users WHERE uid = $uid");
        $result   = $db->query("UPDATE users SET laston = '$laston' WHERE uid = '$uid'");
        dberror($result);
        $update   = $db->query("UPDATE users SET thison = '$dbdate' WHERE uid = '$uid'");
        dberror($result);
    }
    return($uid);
}

function do_newPass($uname)
{
    // generate new random password
    // taken from PHP-Nuke

    $makepass="";
    $syllables="er,in,tia,wol,fe,pre,vet,jo,nes,al,len,son,cha,ir,ler,bo,ok,tio,nar,sim,ple,bla,ten,toe,cho,co,lat,spe,ak,er,po,co,lor,pen,cil,li,ght,wh,at,the,he,ck,is,mam,bo,no,fi,ve,any,way,pol,iti,cs,ra,dio,sou,rce,sea,rch,pa,per,com,bo,sp,eak,st,fi,rst,gr,oup,boy,ea,gle,tr,ail,bi,ble,brb,pri,dee,kay,en,be,se";
    $syllable_array=explode(",", $syllables);
    srand((double)microtime()*1000000);
    for ($count=1;$count<=4;$count++)
    {
        if (rand()%10 == 1)
        {
            $makepass .= sprintf("%0.0f",(rand()%50)+1);
        } else {
            $makepass .= sprintf("%s",$syllable_array[rand()%62]);
        }
    }
    return($makepass);
}

function do_checkUser($uname, $email, $uid, $sessid)
{
    // check user entries for new users (email, name, etc.)
    global $db;

    $msg = NULL;

    if ($sessid == 0)
    {
        // new user
        $result = $db->query("SELECT uname FROM users WHERE (uname='$uname') AND (deleted='0')");
        dberror($result);
        if ($result->numRows() > 0)
        {
            $msg = "<span class=\"text\"><center>" . gettext("ERROR: Username is already taken.") . "</center></span><br />";
        }
        $result->free();
        $result = $db->query("SELECT email FROM users WHERE (email='$email') AND (deleted='0')");
        dberror($result);
        if ($result->numRows() > 0)
        {
            $msg = "<span class=\"text\"><center>" . gettext("ERROR: Email address already taken.") . "</center></span><br />";
        }
        $result->free();
    } else {
        // existing user
        $result = $db->query("SELECT * FROM users WHERE (uname = '$uname') AND (deleted='0')"); 
        dberror($result);
        $userq  = $result->fetchRow(DB_FETCHMODE_ASSOC);
        $result->free();
        if ($uname == $userq['uname'] && $uid != $userq['uid'])
        {
            $msg = "<span class=\"text\"><center>" . gettext("ERROR: Username is already taken.") . "</center></span><br />";
        }
        $result = $db->query("SELECT * FROM users WHERE (email = '$email') AND (deleted='0')"); 
        dberror($result);
        $usere  = $result->fetchRow(DB_FETCHMODE_ASSOC);
        $result->free();
        if ($email == $usere['email'] && $uid != $usere['uid'])
        {
            $msg = "<span class=\"text\"><center>" . gettext("ERROR: Email address already taken.") . "</center></span><br />";
        }
    }
    if ((!$email) || ($email=="") || (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,4}$",$email)))
    {
        $msg = "<span class=\"text\"><center>" . gettext("ERROR: Invalid email address.") . "</center></span><br />";
    }
    if (strrpos($uname,' ') > 0)
    {
        $msg = "<span class=\"text\"><center>" . gettext("ERROR: Email addresses do not contain spaces.") . "</center></span><br />";
    }
    if ((!$uname) || ($uname=="") || (ereg("[^a-zA-Z0-9_-]",$uname)))
    {
        $msg = "<span class=\"text\"><center>" . gettext("ERROR: Invalid username.") . "</center></span><br />";
    }
    if (strlen($uname) > 25)
    {
        $msg = "<span class=\"text\"><center>" . gettext("ERROR: Username is too long.  It must be less than 25 characters.") . "</center></span><br />";
    }
    if (eregi("^((root)|(adm)|(linux)|(webmaster)|(admin)|(god)|(administrator)|(nobody)|(anonymous)|(operator))$",$uname))
    {
        if ($sessid == 0)
        {
            // new user
            $msg = "<span class=\"text\"><center>" . gettext("ERROR: Username is reserved.") . "</center></span><br />";
        } else {
            // existing user
            $result = $db->query("SELECT uid FROM users WHERE uname = '$uname'");
            dberror($result);
            $user  = $result->fetchRow(DB_FETCHMODE_ASSOC);
            $result->free();
            // if user's uid is not 1 (root user)
            if ($user['uid'] != 1)
            {
                $msg = "<span class=\"text\"><center>" . gettext("ERROR: Username is reserved.") . "</center></span><br />";
            }
        }
    }
    return($msg);
}

function do_checkacs($acs)
{
    global $config;
    if ($acs < $config['adminac'])
    {
        print("<span class=\"text\"><center>" . gettext("You do not have access.") . "</center></span>");
        return(0);
    } else {
        return(1);
    }
}

function do_sessioncheck()
{
    // this gets the state for the user
    // much of this code is based on geeklog (geeklog.sourceforge.net),
    // which is in turn based on phpBB (www.phpbb.org).  This checks the
    // session cookie and long term cookie to get the user's state.
    global $_USER, $_CONF, $db;

    // this must be done here so it's set even if the cookie is not present
    $user_logged_in = 0;
    $logged_in      = 0;
    $userdata       = Array();

    // check for cookie on user's machine; if the cookie exists, build an
    // array of the user's info
    if (isset($_COOKIE[$_CONF['cookie_session']]))
    {
        $sessid = $_COOKIE[$_CONF['cookie_session']];
        $userid = do_getuseridfromsession($sessid, $_CONF['cookie_timeout_session'], $_SERVER['REMOTE_ADDR']);

        if ($userid)
        {
            $user_logged_in = 1;
            do_updatesessiontime($sessid);
            $userdata       = do_getuserdatafromid($userid);
            $_USER          = $userdata;
        } else {
            // session probably expired, now check permanent cookie
            if (isset($_COOKIE[$_CONF['cookie_name']]))
            {
                $userid     = $_COOKIE[$_CONF['cookie_name']];
                $cookie_pwd = $_COOKIE['password'];
                $userpass   = $db->getOne("SELECT passwd FROM users WHERE uid = $userid");
                if ($cookie_pwd != $userpass)
                {
                    // user may have modified there uid in cookie; ignore them
                } else {
                    if ($userid)
                    {
                        $user_logged_in = 1;
                        $sess_id  = do_newsession($userid, $_SERVER['REMOTE_ADDR'], $_CONF['cookie_timeout_session']);
                        do_setsessioncookie($sessid, $_CONF['cookie_timeout_session'], $_CONF['cookie_session'], $_CONF['cookie_path'], $_CONF['cookie_domain'], $_CONF['cookie_secure']);
                        $userdata = do_getuserdatafromid($userid);
                        $_USER    = $userdata;
                    } 
                }
            }
        }
    } else {
        // check if the persistent cookie exists
        if (isset($_COOKIE[$_CONF['cookie_name']]))
        {
            // session cookie doesn't exist but a permanent cookie does
            // start a new session cookie
            $userid     = $_COOKIE[$_CONF['cookie_name']];
            $cookie_pwd = $_COOKIE['password'];
            $userpass   = $db->getOne("SELECT passwd FROM users WHERE uid = $userid");
            if ($cookie_pwd != $userpass)
            {
                // user could have modified uid in cookie; ignore them
            } else {
                if ($userid)
                {
                    $user_logged_in = 1;
                    // create new session and write cookie
                    $sessid   = do_newsession($userid, $_SERVER['REMOTE_ADDR'], $_CONF['cookie_timeout_session']);
                    do_setsessioncookie($sessid, $_CONF['cookie_timeout_session'], $_CONF['cookie_session'], $_CONF['cookie_path'], $_CONF['cookie_domain'], $_CONF['cookie_secure']);
                    $userdata = do_getuserdatafromid($userid);
                    $_USER    = $userdata;
                }
            }
        }
    }

    // set expire dates: one for a year, one for 10 minutes
    $expiredate1 = time() + 3600 * 24 * 365;
    $expiredate2 = time() + 600;

    // update the LastVisit cookie; this cookie is updated each time
    // site.inc.php is run
    $ctime = time();
    setcookie('LastVisit', $ctime, $expiredate1, $_CONF['cookie_path'], $_CONF['cookie_domain'], $_CONF['cookie_secure']);

    // set LastVisitTemp cookie, which only gets the time from the LastVisit
    // cookie; if it does not exist yet otherwise, it gets the time from the
    // LastVisitTemp cookie
    if (isset($_COOKIE['LastVisitTemp']))
    {
        $ctime = $_COOKIE['LastVisitTemp'];
    }

    // set cookie
    setcookie('LastVisitTemp', $ctime, $expiredate2, $_CONF['cookie_path'], $_CONF['webroot'], $_CONF['cookie_secure']);

    if (!isset($_USER)) $_USER = NULL;
    return $_USER;
}

function do_newsession($userid, $remoteip, $lifespan)
{
    // add new session to the database for the given userid and return new 
    // session id; also deletes all expired sessions from the database,
    // based on the given lifespan
    global $_CONF, $db;

    mt_srand((double)microtime()*1000000);
    $sessid = mt_rand();

    $currtime   = (string) (time());
    $expirytime = (string) (time() - $lifespan);
    if (!isset($_COOKIE[$_CONF['cookie_session']]))
    {
        // delete any old sessions for this user
        $result = $db->query("DELETE FROM sessions WHERE uid = $userid");
        dberror($result);
    } else {
        $result = $db->query("DELETE FROM sessions WHERE (start_time < $expirytime)");
        dberror($result);
    }

    // create new session
    $query  = "INSERT INTO sessions (sess_id, start_time, remote_ip, uid) ";
    $query .= "VALUES ('$sessid', '$currtime', '$remoteip', '$userid')";
    $result = $db->query($query);
    dberror($result);

    return $sessid;
}

function do_setsessioncookie($sessid, $cookietime, $cookiename, $cookiepath, $cookiedomain, $cookiesecure)
{
    // set a cookie that persists until the user closes their browser
    // since session expiry is handled server-side, cookie expiry time
    //   doesn't matter
    setcookie($cookiename,$sessid,0,$cookiepath,$cookiedomain,$cookiesecure);
}

function do_getuseridfromsession($sessid, $cookietime, $remoteip)
{
    // return the userid associated with the given session based on the given 
    // session lifespan and remote IP; if no match found, return 0
    global $db, $_CONF;

    $mintime = time() - $cookietime;

    $query  = "SELECT uid from sessions WHERE (sess_id = '$sessid') AND ";
    $query .= "(start_time > $mintime) AND (remote_ip = '$remoteip')";
    $result = $db->query($query);
    dberror($result);
    $data   = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();

    if (!$data)
    {
        if (isset($_COOKIE[$_CONF['cookie_name']]))
        {
            return $_COOKIE[$_CONF['cookie_name']];
        } else {
            return 0;
        }
    } else {
        return $data['uid'];
    }
}

function do_updatesessiontime($sessid)
{
    // refresh the start_time of the given session in the database
    // this is called whenever a page is hit by a user with a valid session

    global $db;

    $newtime = (string) time();
    $result  = $db->query("UPDATE sessions SET start_time = '$newtime' WHERE (sess_id = '$sessid')");
    dberror($result);
    return 1;
}

function do_endusersession($userid)
{
    // delete a user session (via logout)

    global $db, $_CONF;

    $result = $db->query("DELETE FROM sessions WHERE (uid = '$userid')");
    dberror($result);

    return 1;
}

function do_getuserdata($username)
{
    // get user's data based on their username

    global $db;

    $result   = $db->query("SELECT * FROM users WHERE (uname = '$username') AND (deleted='0')");
    dberror($result);
    $userdata = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();

    return($userdata);
}

function do_getuserdatafromid($userid)
{
    // get user's data based on their user id

    global $db;

    $result   = $db->query("SELECT * FROM users WHERE uid = '$userid'");
    dberror($result);
    $userdata = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $result->free();

    return($userdata);
}

function do_getusercookietimeout()
{
    global $_CONF, $db, $_USER;

    if (empty($_USER))
    {
        return;
    }

    $timeout = $db->getOne("SELECT cookietimeout FROM users WHERE uid = '" . $_USER['uid'] . "'");
    if (empty($timeout))
    {
        $timeout = $_CONF['cookie_timeout_permdef'];
    }

    return $timeout;
}
  
function do_checkaccess($newusers, $uid, $uname)
{
    if ($newusers == 0 && !isset($uid))
    {
        d_DrawNav($uname);
        d_DrawHeader(gettext("Access Denied"));
        print(gettext("You must be logged in to obtain a report."));
        d_DrawFooter();
        return 1;
    }
}
  
// check access for modifying bug components
function do_queryaccess($owner, $reporter)
{
    global $_USER, $config;
    // return values:
    // 0 - user has no association to bug
    // 1 - user is developer or owner
    // 2 - user is reporter
    
    if ($_USER['uid'] == $owner || $_USER['access'] >= $config['devac'])
    {
        $val = 1;
    } else {
        if ($_USER['uid'] == $reporter)
        {
            $val = 2;
        } else {
            $val = 0;
        }
    }
    
    return($val);
}
  
function term_notadmin()
{
    print("<p>" . gettext("You must be an admin or the owner of this bug to make these changes to this bug.") . "</p>");
    d_DrawFooter();
    exit;
}
  
function term_notreporter()
{
    print("<p>" . gettext("You must be an admin, the owner, or the reporter of this bug to make these changes to this bug.") . "</p>");
    d_DrawFooter();
    exit;
}

?>
