<?
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: showattachment.php,v 1.14 2004/02/04 16:54:53 vdanen Exp $

include("include.php");

// set variables
if (isset($_SERVER['PATH_INFO'])) { $fname = ereg_replace("^/","",$_SERVER['PATH_INFO']); } else { $fname = NULL; }
if (isset($_REQUEST['id']))       { $id    = $_REQUEST['id'];                             } else { $id    = NULL; }

if ($fname == "" && $id == "")
{
    // $fname is not set so there is nothing to see so redirect
    header("Location: " . $_CONF['webroot'] . "/index.php");
    exit;
}

if ($id != "")
{
    // we need to redirect
    $result = $db->query("SELECT * FROM attachidx WHERE atid = $id");
    dberror($result);
    $attach = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $fname  = $attach['filename'];
    $result->free();
    header("Location: " . $_CONF['webroot'] . "/showattachment.php/$id/$fname");
    exit;
}

$f     = explode("/",$fname);
$id    = $f[count($f) -2];
$fname = $f[count($f) -1];

$result = $db->query("SELECT * FROM attachidx WHERE atid = $id");
dberror($result);
$attach = $result->fetchRow(DB_FETCHMODE_ASSOC);
$bug    = $attach['bid'];
$atid   = $attach['atid'];
$type   = $attach['mimetype'];
$name   = $attach['filename'];
$result->free();

if ($fname != $name)
{
    d_StartPage(gettext("Invalid Attachment"));
    d_DrawNav($_USER['uname']);
    d_DrawHeader(gettext("Invalid Attachment"));
    print(gettext("The attachment you selected is unlisted."));
    d_DrawFooter();
    exit();
}  

// if attachment is not found in the database, print error and exit
if (!isset($atid))
{
    d_StartPage(gettext("Invalid Attachment"));
    d_DrawNav($_USER['uname']);
    d_DrawHeader(gettext("Invalid Attachment"));
    print(gettext("The attachment you selected is unlisted."));
    d_DrawFooter();
    exit();
}

$private = $db->getOne("SELECT private FROM bugs WHERE bid = $bug");

if ($private == 1 && !isset($_USER['uid']))
{
    d_StartPage(gettext("Invalid Authorization"));
    d_DrawNav($_USER['uname']);
    d_DrawHeader(gettext("Invalid Authorization"));
    print(gettext("The bug you selected is marked private and is not available to unregistered users."));
    d_DrawFooter();
    exit();
}

$attach = $_CONF['root'] . $_CONF['attachdir'] . "/" . $id . "/" . $name;
$fp   = fopen($attach, "r");
$data = fread($fp, filesize($attach));
fclose($fp);

header("Content-type: $type\n\n");
print($data);
?>
