<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: enterbug.php,v 1.34 2004/02/04 16:54:52 vdanen Exp $

include("include.php");

// set variables
if (isset($_REQUEST['reporter']))  { $reporter  = $_REQUEST['reporter']; }  else { $reporter  = NULL; }
if (isset($_REQUEST['version']))   { $version   = $_REQUEST['version']; }   else { $version   = NULL; }
if (isset($_REQUEST['component'])) { $component = $_REQUEST['component']; } else { $component = NULL; }
if (isset($_REQUEST['prior']))     { $prior     = $_REQUEST['prior']; }     else { $prior     = NULL; }
if (isset($_REQUEST['sever']))     { $sever     = $_REQUEST['sever']; }     else { $sever     = NULL; }
if (isset($_REQUEST['assigned']))  { $assigned  = $_REQUEST['assigned']; }  else { $assigned  = NULL; }
if (isset($_REQUEST['shortdesc'])) { $shortdesc = $_REQUEST['shortdesc']; } else { $shortdesc = NULL; }
if (isset($_REQUEST['url']))       { $url       = $_REQUEST['url']; }       else { $url       = NULL; }
if (isset($_REQUEST['longdesc']))  { $longdesc  = $_REQUEST['longdesc']; }  else { $longdesc  = NULL; }
if (isset($_REQUEST['product']))   { $product   = $_REQUEST['product']; }   else { $product   = NULL; }
if (isset($_REQUEST['pid']))       { $pid       = $_REQUEST['pid']; }       else { $pid       = NULL; }
if (isset($_REQUEST['ebug']))      { $ebug      = $_REQUEST['ebug']; }      else { $ebug      = NULL; }
if (isset($_REQUEST['js']))        { $js        = $_REQUEST['js']; }        else { $js        = NULL; }

d_StartPage(gettext("Submit a Bug"));
d_DrawNav($_USER['uname']);
d_DrawHeader(gettext("Submit a Bug"));
  
if ($config['showrules'] == "1")
{
    if (!isset($ebug) && !isset($pid))
    {
        // show the rules for entering a report
        d_DrawRules();
        d_DrawFooter();
        exit;
    }
}

$result = $db->query("SELECT pid FROM products WHERE deleted = '0'");
dberror($result);
if ($result->numRows() == 1)
{
    $row = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $pid = $row['pid'];
}
$result->free();

if (!isset($pid))
{
    if ($js == "")
    {
        $js = "0";
        $data = <<<EOT
            <form name="tester" action="enterbug.php" method="post">
            <input type="hidden" name="js" value="1">
            <input type="hidden" name="ebug" value="1">
            </form>
            <script><!--
                document.tester.submit()
            // -->
            </script>
EOT;
        print($data);
    }
    $data = NULL;
    $result = $db->query("SELECT * FROM products WHERE deleted = '0' ORDER BY name ASC");
    dberror($result);
    $count   = $result->numRows();
    if ($count > "10")
    {
        // let's keep the select box a reasonable size
        $count = "10";
    }
    $optlist = "";
    $jlist   = "";
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $optlist .= "<option value=\"" . $row['pid'] . "\">" . $row['name'] . "</option>\n";
        $jlist   .= "products['" . $row['pid'] . "'] = \"" . stripslashes($row['description']) . "\";\n";
    }
    $result->free();
    $p_string['selprod'] = gettext("Select Product");

    print("<p><b>" . gettext("You must first select a product in which to enter your new bug") . ":</b></p>\n");
    if ($js == "1")
    {
        $data = <<<EOT
        <script language="JavaScript1.2">
        var products = new Array();
        {$jlist}
        /* Display description of selected product */
        function ShowDescription ( aForm )
        {
            var product     = "";
            var description = "";

            if ( aForm.pid.selectedIndex < 0 )
            {
                aForm.Description.value = "";
                return false;
            }
            for ( var i = 0; i < aForm.pid.length; i++ )
            {
                if ( aForm.pid.options[i].selected )
                {
                    product = aForm.pid.options[i].value;
                }
            }
            aForm.Description.value = products[product];
            return false;
        }
        </script>
EOT;
        $jchange = "onChange=\"ShowDescription(document.getprod)\"";
    } else {
        $jchange = "";
    }
    $data .= <<<EOT
        <form name="getprod" method="GET" action="enterbug.php">
        <table border="0" cellpadding="2" cellspacing="0">
            <tr valign="top"><td valign="top" align="right"><b>Product:</b></td>
            <td valign="top">
                <select name="pid" size="{$count}" {$jchange}>
                {$optlist}
                </select>
            </td>
EOT;
    if ($js == "1")
    {
        $jcolspan = "<td colspan=\"2\">&nbsp;</td>";
        $data .= <<<EOT
            <td valign="top" align="right"><b>Description:</b></td>
            <td valign="top"><textarea name="Description" rows="3" cols="40" wrap="virtual"></textarea></td>
           </tr>
EOT;
    } else {
        $jcolspan = "";
    }
    $data .= <<<EOT
           <tr valign="top"><td>&nbsp;</td><td valign="top">
               <input type="submit" value="{$p_string['selprod']}">
           </td>{$jcolspan}</tr>
        </table>
        </form>
EOT;

    print($data);
} else {
    if (!isset($_USER['uid']))
    {
        // this is anonymous user; no posting permitted
        print("<p>" . gettext("You must login first if you wish to submit a bug.") . "</p>");
        d_DrawFooter();
        exit;
    }
    // check to make sure we have a valid product
    $ptest = $db->getOne("SELECT pid FROM products WHERE (deleted = '0') AND (pid = '$pid')");
    if ($ptest == "")
    {
        print("<p>" . gettext("The product you have selected does not exist.") . "</p>");
        d_DrawFooter();
        exit;
    }
    
    print("<p>" . gettext("This page lets you enter a new bug into Anthill.") . "</p>");

    $p_string['reporter']  = gettext("Reporter");
    $p_string['product']   = gettext("Product");
    $p_string['version']   = gettext("Version");
    $p_string['component'] = gettext("Component");
    $p_string['respri']    = gettext("Priority");
    $p_string['severity']  = gettext("Severity");
    $p_string['assto']     = gettext("Assigned To");
    $p_string['assdef']    = gettext("Leave at default to assign to component owner");
    $p_string['summary']   = gettext("Summary");
    $p_string['incdef']    = gettext("include prefix");
    $p_string['desc']      = gettext("Description");
    $p_string['commit']    = gettext("Commit");
    $p_string['reset']     = gettext("Reset");

    $pname = $db->getOne("SELECT name FROM products WHERE pid = '$pid'");

    // create version select list
    $result = $db->query("SELECT vid,name FROM versions WHERE (product = '$pid') AND (deleted = '0') ORDER BY vid DESC");
    dberror($result);
    $i = NULL;
    if ($result->numRows() == 1)
    {
        $i = 0;
    }
    $ver_sellist = NULL;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        if ($i == "0")
        {
            $selected = "SELECTED";
        } else {
            $selected = "";
        }
        $ver_sellist .= sprintf("<option value=\"%s\" %s>%s</option>\n",$row['vid'],$selected,$row['name']);
        $i++;
    }
    $result->free();

    // create component select list
    $result = $db->query("SELECT cid,name FROM components WHERE (product = '$pid') AND (deleted = '0') ORDER BY name ASC");
    dberror($result);
    $comp_sellist = NULL;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $comp_sellist .= sprintf("<option value=\"%s\">%s</option>\n",$row['cid'],$row['name']);
    }
    $comp_num     = $result->numRows();
    if ($comp_num > "25")
    {
        $compselsize = "size=\"5\"";
    } else {
        $compselsize = "";
    }
    $result->free();

    // create priority select list
    $result = $db->query("SELECT * FROM priority_d");
    dberror($result);
    $pri_sellist = NULL;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        if ($row['s_def'] == 1)
        {
            $def = "SELECTED";
        } else {
            $def = "";
        }
        $pri_sellist .= sprintf("<option value=\"%s\" %s>%s</option>\n",$row['id'],$def,$row['name']);
    }
    $result->free();

    // create severity select list
    $result = $db->query("SELECT * FROM severity_d");
    dberror($result);
    $sev_sellist = NULL;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        if ($row['s_def'] == 1)
        {
            $def = "SELECTED";
        } else {
            $def = "";
        }
        $sev_sellist .= sprintf("<option value=\"%s\" %s>%s</option>\n",$row['id'],$def,$row['name']);
    }
    $result->free();
    // create assigned to list
    $result = $db->query("SELECT uid,email FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY email ASC");
    dberror($result);
    $ass_sellist = "<option value=\"0\">" . gettext("Owner of Component") . "</option>";
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $ass_sellist .= sprintf("<option value=\"%s\">%s</option>\n",$row['uid'],do_transemail($row['email']));
    }
    $ass_num = $result->numRows();
    if ($ass_num > "25")
    {
        $assselsize = "size=\"5\"";
    } else {
        $assselsize = "";
    }
    $result->free();

    $data = <<<EOT
        <form method="post" action="postbug.php">
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td width="10%" align="right" valign="top"><b>{$p_string['reporter']}:</b></td>
                <td width="40%" valign="top">{$_USER['name']}<input type="hidden" name="reporter" value="{$_USER['uid']}"></td>
                <td width="10%" align="right" valign="top"><b>{$p_string['product']}:</b></td>
                <td width="40%" valign="top">{$pname}</td>
            </tr>
            <tr>
                <td width="10%" align="right"><b>{$p_string['version']}:</b></td>
                <td width="40%" valign="top">
                    <select name="version">
                    {$ver_sellist}
                    </select>
                </td>
                <td width="10%" align="right"><b>{$p_string['component']}:</b></td>
                <td width="40%" valign="top">
                    <select name="component" {$compselsize}>
                    {$comp_sellist}
                    </select>
                </td>
            </tr>
            <tr>
                <td width="10%" align="right"><b>{$p_string['respri']}:</b></td>
                <td width="40%" valign="top">
                    <select name="prior">
                    {$pri_sellist}
                    </select>
                </td>
                <td width="10%" align="right"><b>{$p_string['severity']}:</b></td>
                <td width="40%" valign="top">
                    <select name="sever">
                    {$sev_sellist}
                    </select>
                </td>
            </tr>
            <tr>
                <td width="10%" align="right"><b>{$p_string['assto']}:</b></td>
                <td colspan="3" width="90%" valign="top">
                    <select name="assigned" {$assselsize}>
                    {$ass_sellist}
                    </select><span class="tiny">({$p_string['assdef']})</span>
                </td>
            </tr>
            <tr>
                <td width="10%" align="right"><b>{$p_string['summary']}:</b></td>
                <td colspan="3" width="90%">
                    <input type="text" name="shortdesc" size="76" maxlength="100">
                </td>
            </tr>
            <tr>
                <td width="10%" align="right"><b>URL:</b>  ({$p_string['incdef']})</td>
                <td colspan="3" width="90%">
                    <input type="text" name="url" size="76" maxlength="128">
                </td>
            </tr>
            <tr>
                <td width="10%" align="right"><b>{$p_string['desc']}:</b></td>
                <td colspan="3" width="90%">
                    <textarea name="longdesc" cols="76" rows="10" wrap="hard"></textarea>
                </td>
            </tr>
            <tr>
                <td width="10%" align="right">&nbsp;</td>
                <td colspan="3" width="90%">
                    <input type="hidden" name="product" value="{$pid}">&nbsp;&nbsp;&nbsp;&nbsp;
                    <input type="submit" value="     {$p_string['commit']}     ">&nbsp;&nbsp;&nbsp;&nbsp;
                    <input type="reset" value="{$p_string['reset']}">
                </td>
            </tr>
        </table>
        </form>
EOT;

    print($data);
}

d_DrawFooter();
?>
