<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
//
// Anthill - Copyright (c) 2001-2004 Danen Consulting Services
// http://anthill.vmlinuz.ca/
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// $Id: query.php,v 1.71 2004/02/04 16:54:52 vdanen Exp $
  
include("include.php");

// set variables
if (isset($_REQUEST['doit']))       { $doit       = $_REQUEST['doit']; }       else { $doit       = NULL; }
if (isset($_REQUEST['bug']))        { $bug        = $_REQUEST['bug']; }        else { $bug        = NULL; }
if (isset($_REQUEST['comment']))    { $comment    = $_REQUEST['comment']; }    else { $comment    = NULL; }
if (isset($_REQUEST['sbutton']))    { $sbutton    = $_REQUEST['sbutton']; }    else { $sbutton    = NULL; }
if (isset($_REQUEST['resolve']))    { $resolve    = $_REQUEST['resolve']; }    else { $resolve    = NULL; }
if (isset($_REQUEST['dup_id']))     { $dup_id     = $_REQUEST['dup_id']; }     else { $dup_id     = NULL; }
if (isset($_REQUEST['reassign']))   { $reassign   = $_REQUEST['reassign']; }   else { $reassign   = NULL; }
if (isset($_REQUEST['priv']))       { $priv       = $_REQUEST['priv']; }       else { $priv       = NULL; }
if (isset($_REQUEST['postassign'])) { $postassign = $_REQUEST['postassign']; } else { $postassign = NULL; }
if (isset($_REQUEST['comment']))    { $comment    = $_REQUEST['comment']; }    else { $comment    = NULL; }
if (isset($_REQUEST['url']))        { $url        = $_REQUEST['url']; }        else { $url        = NULL; }
if (isset($_REQUEST['shortdesc']))  { $shortdesc  = $_REQUEST['shortdesc']; }  else { $shortdesc  = NULL; }
if (isset($_REQUEST['severity']))   { $severity   = $_REQUEST['severity']; }   else { $severity   = NULL; }
if (isset($_REQUEST['priority']))   { $priority   = $_REQUEST['priority']; }   else { $priority   = NULL; }
if (isset($_REQUEST['fixedver']))   { $fixedver   = $_REQUEST['fixedver']; }   else { $fixedver   = NULL; }
if (isset($_REQUEST['version']))    { $version    = $_REQUEST['version']; }    else { $version    = NULL; }
if (isset($_REQUEST['component']))  { $component  = $_REQUEST['component']; }  else { $component  = NULL; }
if (isset($_REQUEST['btnQuery']))   { $btnQuery   = $_REQUEST['btnQuery']; }   else { $btnQuery   = NULL; }
if (isset($_REQUEST['z']))          { $z          = $_REQUEST['z']; }          else { $z          = "s";  }
if (isset($_REQUEST['request']))    { $request    = $_REQUEST['request']; }    else { $request    = NULL; }
$resolution = NULL;
$syscomm    = NULL;

$dbdate     = date("YmdHis");
  
d_StartPage(gettext("Query Bug"));
if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
d_DrawNav($_USER['uname']);

d_DrawHeader(gettext("Query Bug"));

if (isset($bug))
{
    $result   = $db->query("SELECT assigned,reporter FROM bugs WHERE bid = '$bug'");
    dberror($result);
    $row      = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $bassign  = $row['assigned'];
    $reporter = $row['reporter'];
    $result->free();
}

if (isset($request))
{
    // request a change
    // make sure that the user is logged in and a developer
    if (empty($_USER['uid']))
    {
        print("<p>" . gettext("You must be logged in to make changes to a bug.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
    // now that we know we are a developer, we can operate on the request
    $result = $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
    dberror($result);
    $bugx   = $result->fetchRow(DB_FETCHMODE_ASSOC);
    if ($result->numRows() == 0)
    {
        // empty bug; non-existant
        print("<p><font color=\"red\">" . gettext("The bug you selected does not exist or is invalid.") . "</font></p>");
        d_doQuery($_USER['uid']);
        d_DrawFooter();
        exit();
    }
    $result->free();
    switch ($request)
    {
        case "compchange":
            print("<p>" . gettext("Change the component this bug is assigned to using the following form:") . "</p>\n");
            // theme this later
            print("<form method=\"post\" action=\"query.php\">\n");
            print("<input type=\"hidden\" name=\"bug\" value=\"$bug\">");
            print("<input type=\"hidden\" name=\"doit\" value=\"admin\">");
            $result = $db->query("SELECT * FROM components WHERE (product = '" . $bugx['product'] . "') AND (deleted = '0') ORDER BY name ASC");
            dberror($result);
            if ($result->numRows() > 1)
            {
                print("<select name=\"component\" size=\"5\">");
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
                {
                    if ($row['cid'] == $bugx['component'])
                    {
                        $selected = "SELECTED";
                    } else {
                        $selected = "";
                    }
                    print(sprintf("<option value=\"%s\" %s>%s</option>\n",$row['cid'],$selected,$row['name']));
                    $i++;
                }
                $result->free();
                print("</select><br />");
                print("<input type=\"submit\" value=\"" . gettext("Save Changes") . "\">");
                print("</form>");
                print("<p>" . gettext("Note that ownership of the bug will be retained; if you wish to reassign the bug to the new component's owner, you will have to perform that action seperately.") . "</p>");
            }
            $result->free();
            d_DrawFooter();
            exit;
            break;
        default:
            break;
    }
}

if (isset($doit))
{
    // make changes to bug
    // make sure that the user is logged in (ie. not expired somehow) prior
    // to making changes to the bug
    if (empty($_USER['uid']))
    {
        print("<p>" . gettext("You must be logged in to make changes to a bug.") . "</p>");
        d_DrawFooter();
        exit;
    }
    if ($doit == "add_comment")
    {
        // add comment to bug
        $id     = $db->nextID('bugdesc');
        $query  = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
        $query .= "('$id','$bug','" . $_USER['uid'] . "','$dbdate',0,";
        $query .= "'" . addslashes($comment) . "')";
        $result = $db->query($query);
        dberror($result);

        d_doDiff($bug);
    } elseif ($doit == "add_cc") {
        // add cc to list
        $result = $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
        dberror($result);
        $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);
        if ($row['cc'])
        {
            $tmpcc = split(", ", $row['cc']);
            for ($i=0; $i < count($tmpcc); $i++)
            {
                if ($tmpcc[$i] == $_USER['email'])
                {
                    $exists = 1;
                }
            }
            // if user doesn't exist, add to cc list
            if ($exists != 1)
            {
                // if user doesn't exist, add to list
                $cc = $row['cc'] . ", " . $_USER['email'];
            } else { // if user already in list, use old list
                $cc = $row['cc'];
            }
        } else {
            $cc = $_USER['email'];
        }
        $result->free();
        $result = $db->query("UPDATE bugs SET cc = '$cc' WHERE bid = '$bug'");
        dberror($result);
        do_bugactivity($bug, $_USER['uid'], "3");
    } elseif ($doit == "rem_cc") {
        // remove cc from list
        $result = $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
        dberror($result);
        $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);
        $cc     = split(", ", $row['cc']);
        $count  = 0;
        $newcc  = NULL;
        for ($i=0; $i < count($cc); $i++)
        {
            if ($cc[$i] != $_USER['email'])
            {
                if ($count==0)
                {
                    $newcc = $cc[$i];
                    $count++;
                } else {
                    $newcc .= ", " . $cc[$i];
                    $count++;
                }
            }
        }
        $result->free();
        $result = $db->query("UPDATE bugs SET cc = '$newcc' WHERE bid = '$bug'");
        dberror($result);
        do_bugactivity($bug, $_USER['uid'], "4");
    } elseif ($doit == "admin") {
        switch($sbutton)
        {
            case "nochange":
                // nothing changes
                break;
            case "accept":
                // change bug to "ASSIGNED"
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '2'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '2' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                break;
            case "resolve":
                // change bug to "RESOLVED" with resolution status
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '4'");
                $res    = $db->getOne("SELECT name FROM resolve_d WHERE id = '$resolve'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '4' WHERE bid = '$bug'");
                dberror($result);
                $result = $db->query("UPDATE bugs SET resolution = '$resolve' WHERE bid = '$bug'");
                dberror($result);
                $sdesc  = "$nstat  ($res)";
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $sdesc);
                // If FIXED, allow to set the fixed version
                if ($fixedver != "" && $resolve == 0)
                {
                    $result = $db->query("UPDATE bugs SET fixedver = '$fixedver' WHERE bid = '$bug'");
                    dberror($result);
                }
                break;
            case "duplicate":
                // changed bug to "RESOLVED" with resolution status DUPLICATE
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '4'");
                $res    = $db->getOne("SELECT name FROM resolve_d WHERE id = '3'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '4' WHERE bid = '$bug'");
                dberror($result);
                $result = $db->query("UPDATE bugs SET resolution = '3' WHERE bid = '$bug'");
                dberror($result);
                $comm1  = "This bug has been marked as a duplicate of bug #<a href=\"query.php?bug=$dup_id\">$dup_id</a>\n";
                $comm2  = "Bug #<a href=\"query.php?bug=$bug\">$bug</a> has been marked as a duplicate of this bug.\n";
                $id     = $db->nextID('bugdesc');
                $query  = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
                $query .= "('$id','$dup_id','" . $_USER['uid'] . "','$dbdate',1,";
                $query .= "'" . addslashes($comm2) . "')";
                $result = $db->query($query);
                dberror($result);
                $id     = $db->nextID('bugdesc');
                $query  = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
                $query .= "('$id','$bug','" . $_USER['uid'] . "','$dbdate',1,";
                $query .= "'" . addslashes($comm1) . "')";
                $result = $db->query($query);
                dberror($result);
                $sdesc  = "$nstat ($res (#$dup_id))";
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $sdesc);
                d_doDiff($dup_id);
                break;
            case "reassign":
                // reassign bug
                // get old owner
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $oassg   = $db->getOne("SELECT assigned FROM bugs WHERE bid = '$bug'");
                $oass    = $db->getOne("SELECT email FROM users WHERE uid = '$oassg'");
                // now do the updates
                $oemail  = $db->getOne("SELECT email FROM users WHERE uid = '$reassign'");
                $syscomm = sprintf("This bug has been reassigned to %s.\n", $oemail); 
                $result  = $db->query("UPDATE bugs SET assigned = '$reassign' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "1", $oass, $oemail);
                break;
            case "reassigncomp":
                // reassign to component owner
                // get old owner
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $oassg   = $db->getOne("SELECT assigned FROM bugs WHERE bid = '$bug'");
                $oass    = $db->getOne("SELECT email FROM users WHERE uid = '$oassg'");
                // now do the updates
                $comp    = $db->getOne("SELECT component FROM bugs WHERE bid = '$bug'");
                $owner   = $db->getOne("SELECT owner FROM components WHERE cid = '$comp'");
                $email   = $db->getOne("SELECT email FROM users WHERE uid = '$owner'");
                $syscomm = sprintf("This bug has been reassigned to %s.\n", $email); 
                $result  = $db->query("UPDATE bugs SET assigned = '$owner' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "1", $oass, $email);
                break;
            case "private":
                // make bug private or public
                // get old state
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $privt = $db->getOne("SELECT private FROM bugs WHERE bid = '$bug'");
                if ($privt == 0)
                {
                    $opr = "PUBLIC";
                } else {
                    $opr = "PRIVATE";
                }
                if ($priv == 0)
                {
                    $npr = "PUBLIC";
                } else {
                    $npr = "PRIVATE";
                }
                // now do the updates
                $result = $db->query("UPDATE bugs SET private = '$priv' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "2", $opr, $npr);
                break;
            case "reopen":
                // re-open bug
                // get old status
                if (do_queryaccess($bassign, $reporter) == "0") { term_notreporter(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '3'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '3' WHERE bid = '$bug'");
                dberror($result);
                $result = $db->query("UPDATE bugs SET resolution = '4' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                // zero out fixed-in-version
                $result = $db->query("UPDATE bugs SET fixedver = '' WHERE bid = '$bug'");
                dberror($result);
                $fixedver = "";
                break;
            case "close": 
                // change bug to "CLOSED"
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '6'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '6' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                break;
            case "passign": 
                // change bug to "VERIFIED", "UNCONFIRMED", or "NEEDINFO"
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '$postassign'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '$postassign' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                break;
            case "verify": 
                // change bug to "VERIFIED"
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '5'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '5' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                break;
            case "tovalidate": 
                // change bug to "TOVALIDATE"
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '7'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '7' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                break;
            case "needswork": 
                // change bug to "NEEDSWORK"
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '8'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '8' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                break;
            case "needinfo": 
                // change bug to "NEEDINFO"
                // get old status
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT status FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM status_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM status_d WHERE id = '9'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET status = '9' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "0", $ostat, $nstat);
                break;
            case "severity":
                // change severity level
                // get old severity
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT severity FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM severity_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM severity_d WHERE id = '$severity'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET severity = '$severity' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "7", $ostat, $nstat);
                break;
            case "priority":
                // change resolution priority
                // get old priority
                if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
                $ostat  = $db->getOne("SELECT priority FROM bugs WHERE bid = '$bug'");
                $ostat  = $db->getOne("SELECT name FROM priority_d WHERE id = '$ostat'");
                $nstat  = $db->getOne("SELECT name FROM priority_d WHERE id = '$priority'");
                // now do the updates
                $result = $db->query("UPDATE bugs SET priority = '$priority' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "6", $ostat, $nstat);
                break;
            default:
                $query = "";
                break;
        }
        if ($comment)
        {
            $id     = $db->nextID('bugdesc');
            $query  = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
            $query .= "('$id','$bug','" . $_USER['uid'] . "','$dbdate',0,";
            $query .= "'" . addslashes($comment) . "')";
            $result = $db->query($query);
            dberror($result);
        }
        // system comments
        if ($syscomm)
        {
            $id     = $db->nextID('bugdesc');
            $query  = "INSERT INTO bugdesc (did, bid, b_user, b_date, system, description) VALUES ";
            $query .= "('$id','$bug','" . $_USER['uid'] . "','$dbdate',1,";
            $query .= "'$syscomm')";
            $result = $db->query($query);
            dberror($result);
        }
        if ($url)
        {
            if (do_queryaccess($bassign, $reporter) == "0") { term_notreporter(); }
            $result = $db->query("UPDATE bugs SET url = '" . trim(addslashes($url)) . "' WHERE bid = '$bug'");
            dberror($result);
        }
        if ($version)
        {
            // update the bug's version
            if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
            $result = $db->query("SELECT vid FROM versions WHERE vid = '$version'");
            dberror($result);
            if ($result->numRows() == 1)
            {
                $oversion  = $db->getOne("SELECT version FROM bugs WHERE bid = '$bug'");
                $oversion  = $db->getOne("SELECT name FROM versions WHERE vid = '$oversion'");
                $nversion  = $db->getOne("SELECT name FROM versions WHERE vid = '$version'");
                if ($oversion != $nversion)
                {
                    $result2 = $db->query("UPDATE bugs SET version = '$version' WHERE bid = '$bug'");
                    dberror($result2);
                    do_bugactivity($bug, $_USER['uid'], "9", $oversion, $nversion);
                }
            }
            $result->free();
        }
        if ($component)
        {
            // update the bug's component
            if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
            $result = $db->query("SELECT cid FROM components WHERE cid = '$component'");
            dberror($result);
            if ($result->numRows() == 1)
            {
                $ocomp = $db->getOne("SELECT component FROM bugs WHERE bid = '$bug'");
                $ocomp = $db->getOne("SELECT name FROM components WHERE cid = '$ocomp'");
                $ncomp = $db->getOne("SELECT name FROM components WHERE cid = '$component'");
                if ($ocomp != $ncomp)
                {
                    $result2 = $db->query("UPDATE bugs SET component = '$component' WHERE bid = '$bug'");
                    dberror($result2);
                    do_bugactivity($bug, $_USER['uid'], "10", $ocomp, $ncomp);
                }
            }
            $result->free();
        }
        if ($shortdesc)
        {
            if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
            $ndesc = trim(addslashes($shortdesc));
            $odesc = $db->getOne("SELECT shortdesc FROM bugs WHERE bid = '$bug'");
            $odesc = trim(addslashes($odesc));
            // make sure that the description has actually changed
            if ($ndesc != $odesc)
            {
                $result = $db->query("UPDATE bugs SET shortdesc = '$ndesc' WHERE bid = '$bug'");
                dberror($result);
                do_bugactivity($bug, $_USER['uid'], "8", $odesc, $ndesc);
            }
        }
        // If resolved, allow to set the fixed version
        $result = $db->query("SELECT product,status FROM bugs WHERE bid = '$bug'");
        dberror($result);
        $bugx   = $result->fetchRow(DB_FETCHMODE_ASSOC);
        $result->free();
        if ($fixedver != "" && $bugx['status'] == 0 && $resolve == 0)
        {
            if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
            $result = $db->query("UPDATE bugs SET fixedver = '$fixedver' WHERE bid = '$bug'");
            dberror($result);
        }

        d_doDiff($bug);
    }
    // print a "back to bug" page to minimize accidental refreshes
    print("<p>" . gettext("Your changes have been saved.") . "</p>");
    print(sprintf("<p><a href=\"query.php?bug=%s\">", $bug) . sprintf(gettext("Return to bug #%s"), $bug) . "</a></p>");
    d_DrawFooter();
    exit;
}

if (!isset($bug) || isset($btnQuery))
{
    if (isset($btnQuery) && $_CONF['advq'] == 1)
    {
        // we have an advanced query
        $Parameters = z_ParseQueryArguments($HTTP_POST_VARS);
        // $Columns    = z_CheckBoxesArray("show_", $HTTP_POST_VARS);
        $Columns    = z_OrderedListArray("show_",$HTTP_POST_VARS);	
        $SortList   = z_OrderedListArray("sort_",$HTTP_POST_VARS);
        // while (list ($k,$v) = each ($SortList) ) print "\n<br> $k => $v ";
        $Query      = z_ComposeQuery($Parameters,$SortList); 
        // print("\n <font size=-1 color=blue> <b>[$Query]</font></b> <br> "); flush();
        z_PrintResultSet($Columns,$Query);
        print "\n\n<br>";
        d_DrawFooter();
        exit;
    } else {
        // we have no query, so display our forms
        d_doQuery($_USER['uid'], $z);
        d_DrawFooter();
        exit;
    }
} else {
    $result = $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
    dberror($result);
    $bugx   = $result->fetchRow(DB_FETCHMODE_ASSOC);
    if ($result->numRows() == 0)
    {
        // empty bug; non-existant
        print("<p><font color=\"red\">" . gettext("The bug you selected does not exist or is invalid.") . "</font></p>");
        d_doQuery($_USER['uid']);
        d_DrawFooter();
        exit();
    }
    if ($bugx['private'] == 1 && !isset($_USER['uid']))
    {
        print("<p><font color=\"red\">" . gettext("The bug you selected is marked private and is not available to unregistered users.") . "</font></p>");
        d_doQuery($_USER['uid']);
        d_DrawFooter();
        exit();
    }
    $result->free();

    // get product, version, component info
    $product   = $db->getOne("SELECT name FROM products WHERE pid = '" . $bugx['product'] . "'");
    $version   = $db->getOne("SELECT name FROM versions WHERE vid = '" . $bugx['version'] . "'");
    $component = $db->getOne("SELECT name FROM components WHERE cid = '" . $bugx['component'] . "'");

    // get user info
    $result = $db->query("SELECT email,name,gpg FROM users WHERE uid = '" . $bugx['reporter'] . "'");
    dberror($result);
    $row    = $result->fetchRow(DB_FETCHMODE_ASSOC); 
    $email  = do_transemail($row['email']);
    $rname  = $row['name'];
    if ($row['gpg'] != "")
    {
        $gpg = " [ <a href=\"" . $_CONF['webroot'] . $row['gpg'] . "\">gpg</a> ] ";
    } else {
        $gpg = "";
    }
    $result->free();

    // get status info
    $result = $db->query("SELECT id,name FROM status_d WHERE id = '" . $bugx['status'] . "'");
    dberror($result);
    $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $statid = $row['id'];
    $status = $row['name'];
    $result->free();

    // get severity info
    $result      = $db->query("SELECT id,name FROM severity_d WHERE id = '" . $bugx['severity'] . "'");
    dberror($result);
    $row         = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $severity_id = $row['id'];
    $severity    = $row['name'];
    $result->free();

    // get resolution info
    if ($bugx['resolution'] != "")
    {
        $resolution = $db->getOne("SELECT name FROM resolve_d WHERE id = '" . $bugx['resolution'] . "'");
        if ($resolution == "OPEN")
        {
            $resolution = "";
        }
    }

    // get priority info
    $result      = $db->query("SELECT id,name FROM priority_d WHERE id = '" . $bugx['priority'] . "'");
    dberror($result);
    $row         = $result->fetchRow(DB_FETCHMODE_ASSOC);
    $priority_id = $row['id'];
    $priority    = $row['name'];
    $result->free();

    // get fixed-in-version info (if it exists)
    if ($bugx['fixedver'] != "")
    {
        $fixinver = $bugx['fixedver'];
    } else {
        $fixinver = NULL;
    }

    $p_string['product']     = gettext("Product");
    $p_string['version']     = gettext("Version");
    $p_string['component']   = gettext("Component");
    $p_string['status']      = gettext("Status");
    $p_string['shortsumm']   = gettext("Short Summary");
    $p_string['longdesc']    = gettext("Long Description");
    $p_string['addinfo']     = gettext("Additional Information");
    $p_string['bug']         = gettext("Bug");
    $p_string['status']      = gettext("Status");
    $p_string['resolution']  = gettext("Resolution");
    $p_string['priority']    = gettext("Priority");
    $p_string['assignto']    = gettext("Assigned To");
    $p_string['severity']    = gettext("Severity");
    $p_string['emailcc']     = gettext("Email CC");
    $p_string['reporter']    = gettext("Reporter");
    $p_string['type']        = gettext("Type");
    $p_string['attachments'] = gettext("Attachments");

    $p_shortdesc           = htmlspecialchars(stripslashes($bugx['shortdesc']));
    $d                     = d_getTime($bugx['creation']);
    $p_openedby            = sprintf(gettext("Opened by <a href=\"mailto:%s\">%s</a> %s on %s"), $email, $rname, $gpg, $d); 

    $result = $db->query("SELECT * FROM bugdesc WHERE bid = '" . $bugx['bid'] . "' ORDER BY b_date");
    dberror($result);
    $count  = 0;
    $ldata  = NULL;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        if ($count > 0)
        {
            $cdate   = d_getTime($row['b_date']);
            $result2 = $db->query("SELECT email,name, gpg FROM users WHERE uid = '" . $row['b_user'] . "'");
            dberror($result2);
            $row2    = $result2->fetchRow(DB_FETCHMODE_ASSOC);
            $cemail  = do_transemail($row2['email']);
            if ($row2['gpg'] != "")
            {
                $cgpg  = " [ <a href=\"" . $_CONF['webroot'] . $row2['gpg'] . "\">gpg</a> ] ";
            } else {
                $cgpg  = "";
            }
            $result2->free();
            $ldata .= "<br />------ ";
            $ldata .= sprintf(gettext("Additional comments from <a href=\"mailto:%s\">%s</a> %s on %s"), $cemail, $row2['name'], $cgpg, $cdate);
            $ldata .= " ------<br />";
        }
        if ($row['system'] == 1)
        {
            $ldata .= stripslashes($row['description']);
        } else {
            // sanitize things, we only addslashes when saving to the
            // database so now we have to make things safe
            $ldata .= nl2br(do_transurl(htmlspecialchars(stripslashes($row['description'])),1));
        }
        $ldata .= "<br />";
        $count++;
    }
    $result->free();

    if (isset($fixinver))
    {
        $fixedver = " " . sprintf(gettext("(in version %s)"),$fixinver);
    } else {
        $fixedver = NULL;
    }

    $result = $db->query("SELECT email,name,gpg FROM users WHERE uid = '" . $bugx['assigned'] . "'");
    dberror($result);
    $row    = $result->fetchRow(DB_FETCHMODE_ASSOC);
    if ($row['gpg'] != "")
    {
        $mgpg = " [ <a href=\"" . $_CONF['webroot'] . $row['gpg'] . "\">gpg</a> ] ";
    } else {
        $mgpg = "";
    }
    $p_assignto = sprintf("<a href=\"mailto:%s\">%s</a> %s", do_transemail($row['email']), $row['name'], $mgpg);
    $result->free();

    $p_reporter = sprintf("<a href=\"mailto:%s\">%s</a> %s", $email, $rname, $gpg);
    $p_url      = "<a href=\"" . trim(stripslashes($bugx['url'])) . "\">" . stripslashes($bugx['url']) . "</a>";

    if ($bugx['private'] == 0)
    {
        $p_private = gettext("PUBLIC");
    } else {
        $p_private = gettext("PRIVATE");
    }

    $result = $db->query("SELECT * FROM attachidx WHERE bid = $bug ORDER BY a_date ASC");
    dberror($result);
    $p_attach = NULL;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
    {
        $date = d_getTime($row['a_date']);
        $p_attach = sprintf("id %s: <a href=\"showattachment.php/%s/%s\">%s</a> - %s<br />", $row['atid'], $row['atid'], $row['filename'], $date, $row['filename']);
    }
    $result->free();
    $p_createattach = sprintf("<a href=\"createattachment.php?bug=%s\">" . gettext("Create a new attachment") . "</a> (" .
                      gettext("proposed patch, testcase, etc.") . ")", $bug);

    $p_viewactivity = sprintf("[ <a href=\"activity.php?bug=%s\">" . gettext("View Activity Log") . "</a> ]", $bug);

    $cleancc = do_transemail($bugx['cc']);

    $data = <<<EOT
        <table border="0" cellpadding="0" cellspacing="2" width="100%">
            <tr>
                <td width="20%" align="center" bgcolor="{$config['barcol1']}"><b>{$p_string['product']} - {$p_string['version']}</b></td>
                <td width="20%" align="center" bgcolor="{$config['barcol1']}"><b>{$p_string['component']}</b></td>
                <td width="20%" align="center" bgcolor="{$config['barcol1']}"><b>{$p_string['status']}</b></td>
                <td width="40%" bgcolor="{$config['barcol1']}"><b>{$p_string['shortsumm']}</b></td>
            </tr>
            <tr>
                <td width="20%" align="center" bgcolor="{$config['barcol2']}">{$product}- ${version}</td>
                <td width="20%" align="center" bgcolor="{$config['barcol2']}">{$component}</td>
                <td width="20%" align="center" bgcolor="{$config['barcol2']}">{$status}</td>
                <td width="40%" bgcolor="{$config['barcol2']}">{$p_shortdesc}</td>
            </tr>
            <tr>
                <td colspan="4" width="100%"><br /></td>
            </tr>
            <tr>
                <td width="20%" bgcolor="{$config['barcol1']}"><b>{$p_string['longdesc']}</b></td>
                <td width="80%" colspan="3" bgcolor="{$config['barcol1']}"><b>{$p_openedby}</b></td>
            </tr>
            <tr>
                <td colspan="4" width="100%">
                    {$ldata}
                </td>
            </tr>
        </table>

        <br />

        <table border="0" cellpadding="0" cellspacing="0" width="100%">
            <tr>
                <td colspan="4" width="100%" bgcolor="{$config['barcol1']}"><b>{$p_string['addinfo']}</b></td>
            </tr>
            <tr>
                <td width="20%" align="right" valign="top"><b>{$p_string['bug']}#:</b></td>
                <td width="30%" valign="top">{$bug}</td>
                <td width="20%" align="right" valign="top"><b>{$p_string['product']}:</b></td>
                <td width="30%" valign="top">{$product}</td>
            </tr>
            <tr>
                <td width="20%" align="right" valign="top"><b>{$p_string['status']}:</b></td>
                <td width="30%" valign="top">{$status}</td>
                <td width="20%" align="right" valign="top"><b>{$p_string['component']}:</b></td>
                <td width="30%" valign="top">{$component}</td>
            </tr>
            <tr>
                <td width="20%" align="right" valign="top"><b>{$p_string['resolution']}:</b></td>
                <td width="30%" valign="top">{$resolution} {$fixedver}</td>
                <td width="20%" align="right" valign="top"><b>{$p_string['priority']}:</b></td>
                <td width="30%" valign="top">{$priority}</td>
            </tr>
            <tr>
                <td width="20%" align="right" valign="top"><b>{$p_string['assignto']}:</b></td>
                <td width="30%" valign="top">{$p_assignto}</td>
                <td width="20%" align="right" valign="top"><b>{$p_string['severity']}:</b></td>
                <td width="30%" valign="top">{$severity}</td>
            </tr>
            <tr>
                <td width="20%" align="right" valign="top"><b>{$p_string['emailcc']}:</b></td>
                <td width="30%" valign="top">{$cleancc}</td>
                <td width="20%" align="right" valign="top"><b>{$p_string['reporter']}:</b></td>
                <td width="30%" valign="top">{$p_reporter}</td>
            </tr>
            <tr>
                <td width="20%" align="right" valign="top"><b>URL:</b></td>
                <td width="30%" valign="top">{$p_url}</td>
                <td width="20%" align="right" valign="top"><b>{$p_string['type']}:</b></td>
                <td width="30%" valign="top">{$p_private}</td>
            </tr>
            <tr>
                <td width="20%" align="right" valign="top"><b>{$p_string['attachments']}:</b></td>
                <td width="80%" valign="top" colspan="3">{$p_attach}
                    {$p_createattach}
                </td>
            </tr>
        </table>
        <br />
        <center><p><b>{$p_viewactivity}</b></p></center>
        <br />

EOT;

    $p_string['addmetocc'] = gettext("Add Me to CC List");
    $p_string['removecc']  = gettext("Remove Me from CC List");
    $p_string['subcomm']   = gettext("Submit additional comments on this bug");
    $p_string['plaintext'] = gettext("NOTE: Please use plaintext only; HTML will not be parsed.");

    if (isset($_USER['uid']))
    {
        // only display form to logged in users
        $data .= <<<EOT
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
                <tr>
                    <td width="100%" align="center">
                        <table border="0" cellpadding="0" cellspacing="0">
                            <tr>
                                <td align="center">
                                    <form method="post" action="query.php">
                                    <input type="submit" name="add_cc" value="{$p_string['addmetocc']}">
                                    <input type="hidden" name="bug" value="{$bug}">
                                    <input type="hidden" name="doit" value="add_cc">
                                    </form>
                                </td>
                                <td align="center">
                                    <form method="post" action="query.php">
                                    <input type="submit" name="rem_cc" value="{$p_string['removecc']}">
                                    <input type="hidden" name="bug" value="{$bug}">
                                    <input type="hidden" name="doit" value="rem_cc">
                                    </form>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                </tr>
                <tr>
                    <td width="100%" bgcolor="{$config['barcol1']}"><b>{$p_string['subcomm']}</b></td>
                </tr>
                <tr>
                    <td width="100%" align="center">
                        <form method="post" action="query.php">
                        <textarea name="comment" cols="76" rows="10" wrap="hard"></textarea><br />
                        <span class="tiny">{$p_string['plaintext']}</span>
                    </td>
                </tr>
EOT;

        // begin displaying the stuff to owner, admin, and/or reporter
        if (do_queryaccess($bassign, $reporter) != "0")
        {
            if (do_queryaccess($bassign, $reporter) == "2")
            {
                // if user is reporter
                if ($bugx['status'] == "4" || $bugx['status'] == "6")
                {
                    // let reporter re-open bug
                    $p_string['wanttoreopen'] = gettext("You may choose to re-open this bug if you do not feel it was resolved properly:");
                    $p_string['reopenbug']    = gettext("Re-open bug");
                    $data .= <<<EOT
                        <tr>
                            <td width="100%">
                                <br />{$p_string['wanttoreopen']}<br />
                                <input type="radio" name="sbutton" value="reopen"> {$p_string['reopenbug']}
                            </td>
                        </tr>
EOT;

                }
            }

            $p_string['changeurl'] = gettext("Change URL: (include prefix)");
            $p_surl                = trim(stripslashes($bugx['url']));
            $data .= <<<EOT
                <tr>
                    <td width="100%"><br />{$p_string['changeurl']} <input name="url" size="76" maxlength="128" value="{$p_surl}"></td>
                </tr>
EOT;

        }

        if (do_queryaccess($bassign, $reporter) == "1")
        {
            $p_string['changedesc'] = gettext("Change description");
            $p_sshortdesc           = trim(stripslashes($bugx['shortdesc']));

            // build change product version selection if this product has more than one version
            $p_verlist = NULL;
            $result    = $db->query("SELECT vid,name FROM versions WHERE (product = '" . $bugx['product'] . "') AND (deleted = '0') ORDER BY name ASC");
            dberror($result);
            if ($result->numRows() > 1)
            {
                $p_verlist  = gettext("Change product version:");
                $p_verlist .= "<select name=\"version\">";
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
                {
                    if ($row['vid'] == $bugx['version'])
                    {
                        $selected = "SELECTED";
                    } else {
                        $selected = "";
                    }
                    $p_verlist .= sprintf("<option value=\"%s\" %s>%s</option>\n",$row['vid'],$selected,$row['name']);
                }
                $result->free();
                $p_verlist .= "</select>";
            }

            $p_chcomplink = sprintf("<a href=\"query.php?bug=%s&request=compchange\">" . gettext("Change product component:") . "</a> " . gettext("Assign this bug against a different component"), $bugx['bid']);

            $data .= <<<EOT
                <tr>
                    <td width="100%"><br />{$p_string['changedesc']} <input name="shortdesc" size="76" maxlength="128" value="{$p_sshortdesc}"></td>
                </tr>
                <tr>
                    <td width="100%">
                        <table cellpadding="0" cellspacing="0" border="0" width="100%">
                            <tr>
                                <td width="100%" valign="top">{$p_verlist}</td>
                            </tr>
                            <tr>
                                <td width="100%" valign="top">{$p_chcomplink}</td>
                            </tr>
                        </table>
                    </td>
                </tr>

EOT;

        }

        if (do_queryaccess($bassign, $reporter) == "1")
        {
            $p_string['changestate']  = gettext("Change State or Resolution");
            $p_string['chonlybypriv'] = gettext("only by owner or privileged member");
            $p_string['savechanges']  = gettext("Save Changes");
            $p_string['reset']        = gettext("Reset");

            $p_leavestatbutton  = "<input type=\"radio\" name=\"sbutton\" value=\"nochange\" CHECKED>";
            $p_leavestatbutton .= sprintf(gettext("Leave as <b>%s</b>"), $status) . "<br />";

            $p_acceptbutton     = NULL;
            $p_reqinfobutton    = NULL;
            if ($statid == "1" || $statid == "9")
            {
                // if status "NEW" or "NEEDINFO"
                $p_acceptbutton  = "<input type=\"radio\" name=\"sbutton\" value=\"accept\">";
                $sname = $db->getOne("SELECT name FROM status_d WHERE id = '2'");
                $p_acceptbutton .= sprintf(gettext("Accept problem (change status to <b>%s</b>)"), $sname) . "<br />";
                if ($statid != "9")
                {
                    $p_reqinfobutton  = "<input type=\"radio\" name=\"sbutton\" value=\"needinfo\">";
                    $p_reqinfobutton .= gettext("Bug requires more information from reporter") . "<br />";
                }
            }

            $p_workbutton = NULL;
            if ($statid == "2" || $statid == "9")
            {
                // if status "ASSIGNED" or "NEEDINFO"
                $p_workbutton  = "<input type=\"radio\" name=\"sbutton\" value=\"passign\">";
                $p_workbutton .= gettext("Work on bug, changing status to") . "<select name=\"postassign\">";
                $result = $db->query("SELECT id,name FROM status_d WHERE id = '5' OR id = '0' OR id = '9'");
                dberror($result);
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
                {
                    if ($row['id'] != $statid)
                    {
                        // don't relist current status
                        $p_workbutton .= sprintf("<option value=\"%s\">%s</option>\n",$row['id'],$row['name']);
                    }
                }
                $result->free();
                $p_workbutton .= "</select><br />";
            }

            $p_verifybutton = NULL;
            if ($statid == "0")
            {
                // if status "UNCONFIRMED"
                $p_verifybutton  = "<input type=\"radio\" name=\"sbutton\" value=\"verify\">";
                $p_verifybutton .= gettext("Verify this unconfirmed bug") . "<br />";
            }

            $p_needqabutton   = NULL;
            $p_needworkbutton = NULL;
            $p_needinfobutton = NULL;
            if ($statid == "5" || $statid == "8" || $statid == "7")
            {
                // if status "VERIFIED" or "NEEDSWORK" or "TOVALIDATE"
                if ($statid != "7")
                {
                    // not TOVALIDATE
                    $p_needqabutton  = "<input type=\"radio\" name=\"sbutton\" value=\"tovalidate\">";
                    $p_needqabutton .= gettext("Solution requires testing/validation from QA") . "<br />";
                }
                if ($statid != "8")
                {
                    // not NEEDSWORK
                    $p_needworkbutton  = "<input type=\"radio\" name=\"sbutton\" value=\"needswork\">";
                    $p_needworkbutton .= gettext("Bug requires more work or fix not appropriate") . "<br />";
                }
                $p_needinfobutton  = "<input type=\"radio\" name=\"sbutton\" value=\"needinfo\">";
                $p_needinfobutton .= gettext("Bug requires more information from reporter") . "<br />";
            }

            $p_chgrespributton = NULL;
            $p_chgsevbutton    = NULL;
            $p_resolvebutton   = NULL;
            $p_fixedfield      = NULL;
            $p_mkdupebutton    = NULL;
            $p_closebutton     = NULL;
            $p_reassbutton     = NULL;
            $p_reasownbutton   = NULL;
            $p_pvtbutton       = NULL;
            $p_reopenbutton    = NULL;
            $p_fixedfieldres   = NULL;

            if ($statid != "4" && $statid != "6")
            {
                // if not status "RESOLVED"
                $p_chgrespributton  = "<input type=\"radio\" name=\"sbutton\" value=\"priority\">";
                $p_chgrespributton .= gettext("Change resolution priority to") . "<select name=\"priority\">";
                $result = $db->query("SELECT id,name FROM priority_d");
                dberror($result);
                while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
                {
                    if ($row['id'] == $priority_id)
                    {
                        $def = "SELECTED";
                    } else {
                        $def = "";
                    }
                    $p_chgrespributton .= sprintf("<option value=\"%s\" %s>%s</option>\n",$row['id'],$def,$row['name']);
                }
                $result->free();
                $p_chgrespributton .= "</select><br />";

                $p_chgsevbutton     = "<input type=\"radio\" name=\"sbutton\" value=\"severity\">";
                $p_chgsevbutton    .= gettext("Change bug severity to") . "<select name=\"severity\">";
                $result = $db->query("SELECT id,name FROM severity_d");
                dberror($result);
                while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
                {
                    if ($row['id'] == $severity_id)
                    {
                        $def = "SELECTED";
                    } else {
                        $def = "";
                    }
                    $p_chgsevbutton .= sprintf("<option value=\"%s\" %s>%s</option>\n",$row['id'],$def,$row['name']);
                }
                $result->free();
                $p_chgsevbutton  .= "</select><br />";

                $p_resolvebutton  = "<input type=\"radio\" name=\"sbutton\" value=\"resolve\">";
                $p_resolvebutton .= gettext("Resolve bug, changing resolution to") . "<select name=\"resolve\">";
                $result = $db->query("SELECT id,name FROM resolve_d");
                dberror($result);
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
                {
                    if ($row['id'] != "3" && $row['id'] != "4")
                    {
                        // don't print "DUPLICATE" or "OPEN"
                        $p_resolvebutton .= sprintf("<option value=\"%s\">%s</option>\n",$row['id'],$row['name']);
                    }
                }
                $result->free();
                $p_resolvebutton .= "</select><br />";

                $p_fixedfield     = gettext("If FIXED, you may also select a version:");
                $p_fixedfield    .= "<input type=\"text\" name=\"fixedver\" size=\"8\" maxsize=\"8\"><br />";

                $p_mkdupebutton   = "<input type=\"radio\" name=\"sbutton\" value=\"duplicate\">";
                $p_mkdupebutton  .= gettext("Resolve bug, make it a duplicate of problem") . " #";
                $p_mkdupebutton  .= "<input type=\"text\" name=\"dup_id\" size=\"6\" maxsize=\"6\"><br />";

                $p_closebutton    = "<input type=\"radio\" name=\"sbutton\" value=\"close\">";
                $p_closebutton   .= gettext("Close bug with no resolution") . "<br />";

                $p_reassbutton    = "<input type=\"radio\" name=\"sbutton\" value=\"reassign\">";
                $p_reassbutton   .= gettext("Reassign problem to") . "<select name=\"reassign\">";
                $result = $db->query("SELECT uid,email FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0')");
                dberror($result);
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
                {
                    $p_reassbutton .= sprintf("<option value=\"%s\">%s</option>\n",$row['uid'],do_transemail($row['email']));
                }
                $result->free();
                $p_reassbutton   .= "</select><br />";

                $p_reasownbutton  = "<input type=\"radio\" name=\"sbutton\" value=\"reassigncomp\">";
                $p_reasownbutton .= gettext("Reassign problem to owner of selected component") . "<br />";

                $p_pvtbutton      = "<input type=\"radio\" name=\"sbutton\" value=\"private\">";
                if ($bugx['private'] == 0)
                {
                    $p_pvtbutton .= gettext("Mark this bug private");
                    $p_pvtbutton .= "<input type=\"hidden\" name=\"priv\" value=\"1\">";
                } else {
                    $p_pvtbutton .= gettext("Mark this bug public");
                    $p_pvtbutton .= "<input type=\"hidden\" name=\"priv\" value=\"0\">";
                }
            } else { 
                // if status "RESOLVED"
                $p_reopenbutton  = "<input type=\"radio\" name=\"sbutton\" value=\"reopen\">";
                $p_reopenbutton .= gettext("Re-open bug") . "<br />";

                $p_fixedfieldres  = gettext("If FIXED, you may also select a version:");
                $p_fixedfieldres .= "<input type=\"text\" name=\"fixedver\" size=\"8\" maxsize=\"8\" value=\"$fixinver\"><br />";
            }

            $data .= <<<EOT
                </table>
                <br />
                <table border="0" cellpadding="0" cellspacing="0" width="100%">
                    <tr>
                        <td width="100%" bgcolor="{$config['barcol1']}"><b>{$p_string['changestate']}</b> ({$p_string['chonlybypriv']})</td>
                    </tr>
                    <tr>
                        <td width="100%">
                            {$p_leavestatbutton}
                            {$p_acceptbutton}
                            {$p_reqinfobutton}
                            {$p_workbutton}
                            {$p_verifybutton}
                            {$p_needqabutton}
                            {$p_needworkbutton}
                            {$p_needinfobutton}
                            {$p_chgrespributton}
                            {$p_chgsevbutton}
                            {$p_resolvebutton}
                            {$p_fixedfield}
                            {$p_mkdupebutton}
                            {$p_closebutton}
                            {$p_reassbutton}
                            {$p_reasownbutton}
                            {$p_pvtbutton}
                            {$p_reopenbutton}
                            {$p_fixedfieldres}
                        </td>
                    </tr>
                    <tr>
                        <td width="100%" valign="center">
                            <input type="submit" value="{$p_string['savechanges']}">
                            <input type="reset" value="{$p_string['reset']}">
                            <input type="hidden" name="bug" value="{$bug}">
                            <input type="hidden" name="doit" value="admin">
                            </form>
                        </td>
                    </tr>
                </table>

EOT;

        } else {

            $p_string['addcomment'] = gettext("Add Comment");
            $p_hiddentype           = NULL;

            if (do_queryaccess($bassign, $reporter) != "0")
            {
                // we need the doit button to make url/etc. changes
                $p_hiddentype = "<input type=\"hidden\" name=\"doit\" value=\"admin\">";
            }

            $data .= <<<EOT
                <tr>
                    <td width="100%" align="center">
                        <input type="submit" name="add_comment" value="{$p_string['addcomment']}">
                        <input type="hidden" name="doit" value="add_comment">
                        <input type="hidden" name="bug" value="{$bug}">
                        {$p_hiddentype}
                        </form>
                    </td>
                </tr>
            </table>
EOT;

        }
        print($data);
    } else { 
        print($data);
        print("</table>");
    } // end isset($_USER['uid'])

} // end isset($bug)

d_DrawFooter();
?>
